Interface HttpClientResponse
- All Superinterfaces:
HttpResponseHead, ReadStream<Buffer>, StreamBase
Represents a client-side HTTP response.
Vert.x provides you with one of these via the handler that was provided when creating the HttpClientRequest
or that was set on the HttpClientRequest instance.
It implements ReadStream so it can be used with
Pipe to pipe data with flow control.
- Author:
- Tim Fox
-
Method Summary
Modifier and TypeMethodDescriptionbody()Convenience method for receiving the entire request body in one piece.default HttpClientResponsebodyHandler(Handler<Buffer> bodyHandler) Convenience method for receiving the entire request body in one piece.customFrameHandler(Handler<HttpFrame> handler) Set an custom frame handler.end()Returns a future signaling when the response has been fully received successfully or failed.endHandler(Handler<Void> endHandler) Set an end handler.exceptionHandler(Handler<Throwable> handler) Set an exception handler on the read stream.fetch(long amount) Fetch the specifiedamountof elements.getTrailer(String trailerName) Return the first trailer value with the specified nameSet a data handler.pause()Pause theReadStream, it sets the buffer infetchmode and clears the actual demand.request()resume()Resume reading, and sets the buffer inflowingmode.streamPriorityHandler(Handler<StreamPriority> handler) Set an handler for stream priority changes.trailers()Methods inherited from interface HttpResponseHead
cookies, getHeader, getHeader, headers, statusCode, statusMessage, versionMethods inherited from interface ReadStream
blockingStream, collect, pipe, pipeTo
-
Method Details
-
fetch
Description copied from interface:ReadStreamFetch the specifiedamountof elements. If theReadStreamhas been paused, reading will recommence with the specifiedamountof items, otherwise the specifiedamountwill be added to the current stream demand.- Specified by:
fetchin interfaceReadStream<Buffer>- Returns:
- a reference to this, so the API can be used fluently
-
resume
HttpClientResponse resume()Description copied from interface:ReadStreamResume reading, and sets the buffer inflowingmode. If theReadStreamhas been paused, reading will recommence on it.- Specified by:
resumein interfaceReadStream<Buffer>- Returns:
- a reference to this, so the API can be used fluently
-
exceptionHandler
Description copied from interface:ReadStreamSet an exception handler on the read stream.- Specified by:
exceptionHandlerin interfaceReadStream<Buffer>- Specified by:
exceptionHandlerin interfaceStreamBase- Parameters:
handler- the exception handler- Returns:
- a reference to this, so the API can be used fluently
-
handler
Description copied from interface:ReadStreamSet a data handler. As data is read, the handler will be called with the data.- Specified by:
handlerin interfaceReadStream<Buffer>- Returns:
- a reference to this, so the API can be used fluently
-
pause
HttpClientResponse pause()Description copied from interface:ReadStreamPause theReadStream, it sets the buffer infetchmode and clears the actual demand.While it's paused, no data will be sent to the data
handler.- Specified by:
pausein interfaceReadStream<Buffer>- Returns:
- a reference to this, so the API can be used fluently
-
endHandler
Description copied from interface:ReadStreamSet an end handler. Once the stream has ended, and there is no more data to be read, this handler will be called.- Specified by:
endHandlerin interfaceReadStream<Buffer>- Returns:
- a reference to this, so the API can be used fluently
-
netSocket
NetSocket netSocket()- Returns:
- a
NetSocketfacade to interact with the HTTP client response.
-
getTrailer
-
trailers
MultiMap trailers()- Returns:
- the trailers
-
bodyHandler
Convenience method for receiving the entire request body in one piece.This saves you having to manually set a dataHandler and an endHandler and append the chunks of the body until the whole body received. Don't use this if your request body is large - you could potentially run out of RAM.
- Parameters:
bodyHandler- This handler will be called after all the body has been received
-
body
Convenience method for receiving the entire request body in one piece.This saves you having to manually set a dataHandler and an endHandler and append the chunks of the body until the whole body received. Don't use this if your request body is large - you could potentially run out of RAM.
- Returns:
- a future completed with the body result
-
end
-
customFrameHandler
Set an custom frame handler. The handler will get notified when the http stream receives an custom HTTP/2 frame. HTTP/2 permits extension of the protocol.- Returns:
- a reference to this, so the API can be used fluently
-
request
HttpClientRequest request()- Returns:
- the corresponding request
-
streamPriorityHandler
Set an handler for stream priority changes. This is not implemented for HTTP/1.x.- Parameters:
handler- the handler to be called when the stream priority changes
-